blob: b3d995f562a4228fb0f934907804f7aa40b8824e [file] [log] [blame]
Jonathan Niederc74c7202013-11-25 13:03:06 -08001# Test framework for git. See t/README for usage.
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07002#
3# Copyright (c) 2005 Junio C Hamano
4#
Michal Sojka64b90322010-04-16 15:53:59 +02005# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
Junio C Hamanoe1970ce2005-05-13 22:50:32 -070017
Junio C Hamano3c8f12c2012-06-24 22:01:35 -070018# Test the binaries we have just built. The tests are kept in
19# t/ subdirectory and are run in 'trash directory' subdirectory.
20if test -z "$TEST_DIRECTORY"
21then
22 # We allow tests to override this, in case they want to run tests
23 # outside of t/, e.g. for running tests on the test library
24 # itself.
25 TEST_DIRECTORY=$(pwd)
Felipe Contreras85176d72013-11-17 23:12:43 -050026else
27 # ensure that TEST_DIRECTORY is an absolute path so that it
28 # is valid even if the current working directory is changed
29 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
Junio C Hamano3c8f12c2012-06-24 22:01:35 -070030fi
31if test -z "$TEST_OUTPUT_DIRECTORY"
32then
33 # Similarly, override this to store the test-results subdir
34 # elsewhere
35 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
36fi
37GIT_BUILD_DIR="$TEST_DIRECTORY"/..
38
Jeff Kingd0cc5792017-07-10 09:24:35 -040039# If we were built with ASAN, it may complain about leaks
40# of program-lifetime variables. Disable it by default to lower
41# the noise level. This needs to happen at the start of the script,
42# before we even do our "did we build git yet" check (since we don't
43# want that one to complain to stderr).
Jeff Kingbf1ce902017-07-10 09:24:39 -040044: ${ASAN_OPTIONS=detect_leaks=0:abort_on_error=1}
Jeff Kingd0cc5792017-07-10 09:24:35 -040045export ASAN_OPTIONS
46
Jeff King85b81b32017-09-05 09:04:04 -040047# If LSAN is in effect we _do_ want leak checking, but we still
48# want to abort so that we notice the problems.
49: ${LSAN_OPTIONS=abort_on_error=1}
50export LSAN_OPTIONS
51
Johannes Schindelin8abfdf42018-11-14 08:32:11 -080052if test ! -f "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
Ramkumar Ramachandra2006f0a2012-09-17 22:36:19 +053053then
Johannes Schindelin8abfdf42018-11-14 08:32:11 -080054 echo >&2 'error: GIT-BUILD-OPTIONS missing (has Git been built?).'
Ramkumar Ramachandra2006f0a2012-09-17 22:36:19 +053055 exit 1
56fi
Junio C Hamano3c8f12c2012-06-24 22:01:35 -070057. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
58export PERL_PATH SHELL_PATH
59
Junio C Hamanoc2116a12008-03-06 19:04:26 -080060################################################################
61# It appears that people try to run tests without building...
Johannes Schindelin8abfdf42018-11-14 08:32:11 -080062"${GIT_TEST_INSTALLED:-$GIT_BUILD_DIR}/git$X" >/dev/null
Junio C Hamanoe1970ce2005-05-13 22:50:32 -070063if test $? != 1
64then
Johannes Schindelined306e42018-11-14 08:32:10 -080065 if test -n "$GIT_TEST_INSTALLED"
66 then
67 echo >&2 "error: there is no working Git at '$GIT_TEST_INSTALLED'"
68 else
69 echo >&2 'error: you do not seem to have built git yet.'
70 fi
Pavel Roskind9bdd392005-08-10 22:10:01 -040071 exit 1
Junio C Hamanoe1970ce2005-05-13 22:50:32 -070072fi
Junio C Hamanoc2116a12008-03-06 19:04:26 -080073
Ramkumar Ramachandra4cde5192012-09-22 10:25:10 +053074# if --tee was passed, write the output not only to the terminal, but
75# additionally to the file test-results/$BASENAME.out, too.
76case "$GIT_TEST_TEE_STARTED, $* " in
77done,*)
78 # do not redirect again
79 ;;
SZEDER Gábora5f52c62018-10-29 13:13:59 +010080*' --tee '*|*' --va'*|*' -V '*|*' --verbose-log '*)
John Keeping2d14e132013-04-29 19:16:21 +010081 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
82 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
Jeff King452320f2016-10-21 06:48:00 -040083
84 # Make this filename available to the sub-process in case it is using
85 # --verbose-log.
86 GIT_TEST_TEE_OUTPUT_FILE=$BASE.out
87 export GIT_TEST_TEE_OUTPUT_FILE
88
89 # Truncate before calling "tee -a" to get rid of the results
90 # from any previous runs.
91 >"$GIT_TEST_TEE_OUTPUT_FILE"
92
Jeff King3f824e92017-12-08 05:47:22 -050093 (GIT_TEST_TEE_STARTED=done ${TEST_SHELL_PATH} "$0" "$@" 2>&1;
Jeff King452320f2016-10-21 06:48:00 -040094 echo $? >"$BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
Jeff King925bdc92016-10-21 06:42:10 -040095 test "$(cat "$BASE.exit")" = 0
Ramkumar Ramachandra4cde5192012-09-22 10:25:10 +053096 exit
97 ;;
98esac
99
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700100# For repeatability, reset the environment to known value.
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400101# TERM is sanitized below, after saving color control sequences.
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700102LANG=C
103LC_ALL=C
104PAGER=cat
105TZ=UTC
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400106export LANG LC_ALL PAGER TZ
Eric Wong8ff99e72006-07-11 12:01:54 -0700107EDITOR=:
Ævar Arnfjörð Bjarmason6cdccfc2018-11-08 21:15:29 +0000108
109# GIT_TEST_GETTEXT_POISON should not influence git commands executed
110# during initialization of test-lib and the test repo. Back it up,
111# unset and then restore after initialization is finished.
112if test -n "$GIT_TEST_GETTEXT_POISON"
113then
114 GIT_TEST_GETTEXT_POISON_ORIG=$GIT_TEST_GETTEXT_POISON
115 unset GIT_TEST_GETTEXT_POISON
116fi
117
Stefano Lattarini661bfd12012-03-02 19:48:36 +0100118# A call to "unset" with no arguments causes at least Solaris 10
119# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
120# deriving from the command substitution clustered with the other
121# ones.
Junio C Hamano3c8f12c2012-06-24 22:01:35 -0700122unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
Jonathan Nieder95a1d122011-03-15 05:10:45 -0500123 my @env = keys %ENV;
Jens Lehmann730477f2011-03-28 21:16:09 +0200124 my $ok = join("|", qw(
125 TRACE
126 DEBUG
Jens Lehmann730477f2011-03-28 21:16:09 +0200127 TEST
128 .*_TEST
129 PROVE
130 VALGRIND
René Scharfeac001282013-01-06 18:47:57 +0100131 UNZIP
Nguyễn Thái Ngọc Duyedb54082013-01-15 20:50:56 +0700132 PERF_
Jeff Kinge2a0ccc2014-05-22 05:28:50 -0400133 CURL_VERBOSE
Elia Pinto4527aa12016-09-05 10:24:42 +0000134 TRACE_CURL
Jens Lehmann730477f2011-03-28 21:16:09 +0200135 ));
136 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
Jonathan Nieder95a1d122011-03-15 05:10:45 -0500137 print join("\n", @vars);
138')
Genki Sky7976e902018-02-15 21:46:04 -0500139unset XDG_CACHE_HOME
Jeff King5adf84e2012-07-24 07:53:05 -0400140unset XDG_CONFIG_HOME
Benoit Person8bade1e2013-07-04 22:38:55 +0200141unset GITPERLLIB
Junio C Hamano29e55cd2006-02-10 19:11:23 -0800142GIT_AUTHOR_EMAIL=author@example.com
143GIT_AUTHOR_NAME='A U Thor'
Junio C Hamano29e55cd2006-02-10 19:11:23 -0800144GIT_COMMITTER_EMAIL=committer@example.com
145GIT_COMMITTER_NAME='C O Mitter'
Shawn O. Pearce8d0fc482007-02-04 00:45:47 -0500146GIT_MERGE_VERBOSITY=5
Junio C Hamanof8246282012-01-10 22:44:45 -0800147GIT_MERGE_AUTOEDIT=no
148export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
Junio C Hamano29e55cd2006-02-10 19:11:23 -0800149export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
150export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
Jonathan Niederd33738d2009-11-11 17:56:07 -0600151export EDITOR
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700152
Karsten Blees124647c2014-07-12 02:03:01 +0200153# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
154GIT_TRACE_BARE=1
155export GIT_TRACE_BARE
156
Ben Peart4cb54d02018-09-18 23:29:35 +0000157check_var_migration () {
Junio C Hamano4231d1b2018-09-20 11:43:43 -0700158 # the warnings and hints given from this helper depends
159 # on end-user settings, which will disrupt the self-test
160 # done on the test framework itself.
161 case "$GIT_TEST_FRAMEWORK_SELFTEST" in
162 t) return ;;
163 esac
164
Ben Peart4cb54d02018-09-18 23:29:35 +0000165 old_name=$1 new_name=$2
166 eval "old_isset=\${${old_name}:+isset}"
167 eval "new_isset=\${${new_name}:+isset}"
Junio C Hamano4231d1b2018-09-20 11:43:43 -0700168
Ben Peart4cb54d02018-09-18 23:29:35 +0000169 case "$old_isset,$new_isset" in
170 isset,)
171 echo >&2 "warning: $old_name is now $new_name"
172 echo >&2 "hint: set $new_name too during the transition period"
173 eval "$new_name=\$$old_name"
174 ;;
175 isset,isset)
176 # do this later
177 # echo >&2 "warning: $old_name is now $new_name"
178 # echo >&2 "hint: remove $old_name"
179 ;;
180 esac
181}
182
183check_var_migration GIT_FSMONITOR_TEST GIT_TEST_FSMONITOR
Ben Peart1f357b02018-09-18 23:29:36 +0000184check_var_migration TEST_GIT_INDEX_VERSION GIT_TEST_INDEX_VERSION
Ben Peart5765d972018-09-18 23:29:37 +0000185check_var_migration GIT_FORCE_PRELOAD_TEST GIT_TEST_PRELOAD_INDEX
Ben Peart1f357b02018-09-18 23:29:36 +0000186
187# Use specific version of the index file format
188if test -n "${GIT_TEST_INDEX_VERSION:+isset}"
Thomas Gummerer5d9fc882014-02-23 21:49:58 +0100189then
Ben Peart1f357b02018-09-18 23:29:36 +0000190 GIT_INDEX_VERSION="$GIT_TEST_INDEX_VERSION"
Thomas Gummerer5d9fc882014-02-23 21:49:58 +0100191 export GIT_INDEX_VERSION
192fi
193
Elia Pintoa731fa92012-09-14 09:54:22 -0700194# Add libc MALLOC and MALLOC_PERTURB test
195# only if we are not executing the test with valgrind
Junio C Hamano1b3185f2012-09-14 20:38:24 -0700196if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
René Scharfeee1431b2012-09-26 22:16:39 +0200197 test -n "$TEST_NO_MALLOC_CHECK"
Junio C Hamano1b3185f2012-09-14 20:38:24 -0700198then
199 setup_malloc_check () {
200 : nothing
201 }
202 teardown_malloc_check () {
203 : nothing
204 }
205else
206 setup_malloc_check () {
207 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
208 export MALLOC_CHECK_ MALLOC_PERTURB_
209 }
210 teardown_malloc_check () {
211 unset MALLOC_CHECK_ MALLOC_PERTURB_
212 }
213fi
Elia Pintoa731fa92012-09-14 09:54:22 -0700214
Junio C Hamano886a3902007-04-24 11:21:47 -0700215# Protect ourselves from common misconfiguration to export
216# CDPATH into the environment
217unset CDPATH
218
Bert Wesarg5565f472009-11-18 17:15:19 +0100219unset GREP_OPTIONS
René Scharfeac001282013-01-06 18:47:57 +0100220unset UNZIP
Bert Wesarg5565f472009-11-18 17:15:19 +0100221
Robin Rosenberg3d5c0cc2006-09-23 00:35:20 +0200222case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
Ramsay Jones1c0cc752012-09-01 19:11:49 +01002231|2|true)
Jeff King025232e2015-03-13 00:50:56 -0400224 GIT_TRACE=4
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100225 ;;
Christian Couder6ce4e612006-09-02 18:23:48 +0200226esac
227
Junio C Hamanocd3c0952009-09-20 11:10:14 -0700228# Convenience
229#
Charles Bailey5555a2a2017-11-12 15:25:23 +0000230# A regexp to match 5, 35 and 40 hexdigits
Junio C Hamanocd3c0952009-09-20 11:10:14 -0700231_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
Charles Bailey5555a2a2017-11-12 15:25:23 +0000232_x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
233_x40="$_x35$_x05"
Junio C Hamanocd3c0952009-09-20 11:10:14 -0700234
Junio C Hamano3749fde2011-04-23 22:34:13 -0700235# Zero SHA-1
236_z40=0000000000000000000000000000000000000000
237
brian m. carlsonbd981d52018-05-13 02:24:14 +0000238OID_REGEX="$_x40"
brian m. carlson198857b2018-05-13 02:24:12 +0000239ZERO_OID=$_z40
Nguyễn Thái Ngọc Duyf9e7d9f2016-07-16 07:06:24 +0200240EMPTY_TREE=4b825dc642cb6eb9a060e54bf8d69288fbee4904
Nguyễn Thái Ngọc Duy378932d2016-07-16 07:06:25 +0200241EMPTY_BLOB=e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
Nguyễn Thái Ngọc Duyf9e7d9f2016-07-16 07:06:24 +0200242
Junio C Hamano3f4ab622011-08-08 11:51:00 -0700243# Line feed
244LF='
245'
246
Jeff Kinga42643a2014-12-15 18:15:20 -0500247# UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
248# when case-folding filenames
249u200c=$(printf '\342\200\214')
250
brian m. carlsonbd981d52018-05-13 02:24:14 +0000251export _x05 _x35 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB ZERO_OID OID_REGEX
Thomas Rast342e9ef2012-02-17 11:25:09 +0100252
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700253# Each test should start with something like this, after copyright notices:
254#
255# test_description='Description of this test...
256# This test checks if command xyzzy does the right thing...
257# '
258# . ./test-lib.sh
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400259test "x$TERM" != "xdumb" && (
Richard Hansenca92a662015-06-17 15:06:25 -0400260 test -t 1 &&
261 tput bold >/dev/null 2>&1 &&
262 tput setaf 1 >/dev/null 2>&1 &&
263 tput sgr0 >/dev/null 2>&1
264 ) &&
265 color=t
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700266
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700267while test "$#" -ne 0
268do
269 case "$1" in
270 -d|--d|--de|--deb|--debu|--debug)
271 debug=t; shift ;;
Junio C Hamano886856a2005-05-14 00:24:27 -0700272 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
273 immediate=t; shift ;;
Lea Wiemann5e2c08c2008-06-17 03:29:02 +0200274 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
Junio C Hamano91e80b92009-02-18 11:17:27 -0800275 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
Ilya Bobyr0445e6f2014-04-30 02:50:44 -0700276 -r)
277 shift; test "$#" -ne 0 || {
278 echo 'error: -r requires an argument' >&2;
279 exit 1;
280 }
281 run_list=$1; shift ;;
282 --run=*)
SZEDER Gábor0ff74102016-04-22 22:32:21 +0200283 run_list=${1#--*=}; shift ;;
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700284 -h|--h|--he|--hel|--help)
Michele Ballabio570f3222007-11-10 15:17:25 +0100285 help=t; shift ;;
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700286 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
287 verbose=t; shift ;;
Thomas Rastff09af32013-06-23 20:12:56 +0200288 --verbose-only=*)
SZEDER Gábor0ff74102016-04-22 22:32:21 +0200289 verbose_only=${1#--*=}
Thomas Rastff09af32013-06-23 20:12:56 +0200290 shift ;;
Pierre Habouzit1ece1272007-10-24 22:03:39 +0200291 -q|--q|--qu|--qui|--quie|--quiet)
Ævar Arnfjörð Bjarmason092c4332010-07-31 16:40:05 +0000292 # Ignore --quiet under a TAP::Harness. Saying how many tests
293 # passed without the ok/not ok details is always an error.
294 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
Matthew Ogilviee4597aa2009-12-02 22:14:06 -0700295 --with-dashes)
296 with_dashes=t; shift ;;
Pierre Habouzit55db1df2007-10-24 22:03:38 +0200297 --no-color)
Clemens Buchacherfaa4bc32008-02-27 20:28:45 +0100298 color=; shift ;;
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100299 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
Thomas Rast952af352013-03-31 10:00:16 +0200300 valgrind=memcheck
301 shift ;;
302 --valgrind=*)
SZEDER Gábor0ff74102016-04-22 22:32:21 +0200303 valgrind=${1#--*=}
Thomas Rast952af352013-03-31 10:00:16 +0200304 shift ;;
Thomas Rast5dfc3682013-06-23 20:12:57 +0200305 --valgrind-only=*)
SZEDER Gábor0ff74102016-04-22 22:32:21 +0200306 valgrind_only=${1#--*=}
Thomas Rast5dfc3682013-06-23 20:12:57 +0200307 shift ;;
Johannes Schindelin44138552009-02-04 00:26:12 +0100308 --tee)
309 shift ;; # was handled already
Jeff Kingf423ef52009-08-09 04:39:45 -0400310 --root=*)
SZEDER Gábor0ff74102016-04-22 22:32:21 +0200311 root=${1#--*=}
Jeff Kingf423ef52009-08-09 04:39:45 -0400312 shift ;;
Jeff Kingbb79af92015-03-20 06:05:48 -0400313 --chain-lint)
314 GIT_TEST_CHAIN_LINT=1
315 shift ;;
316 --no-chain-lint)
317 GIT_TEST_CHAIN_LINT=0
318 shift ;;
Jeff Kinga136f6d2014-10-10 02:47:27 -0400319 -x)
SZEDER Gábor5fc98e72018-02-24 00:39:42 +0100320 # Some test scripts can't be reliably traced with '-x',
321 # unless the test is run with a Bash version supporting
322 # BASH_XTRACEFD (introduced in Bash v4.1). Check whether
323 # this test is marked as such, and ignore '-x' if it
324 # isn't executed with a suitable Bash version.
325 if test -z "$test_untraceable" || {
326 test -n "$BASH_VERSION" && {
327 test ${BASH_VERSINFO[0]} -gt 4 || {
328 test ${BASH_VERSINFO[0]} -eq 4 &&
329 test ${BASH_VERSINFO[1]} -ge 1
330 }
331 }
332 }
333 then
334 trace=t
335 else
336 echo >&2 "warning: ignoring -x; '$0' is untraceable without BASH_XTRACEFD"
337 fi
Jeff Kinga136f6d2014-10-10 02:47:27 -0400338 shift ;;
SZEDER Gábora5f52c62018-10-29 13:13:59 +0100339 -V|--verbose-log)
Jeff King452320f2016-10-21 06:48:00 -0400340 verbose_log=t
341 shift ;;
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700342 *)
Clemens Buchacher1f729dc2009-06-01 14:14:40 +0200343 echo "error: unknown test option '$1'" >&2; exit 1 ;;
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700344 esac
345done
346
Thomas Rast26a07302013-10-19 23:06:07 +0200347if test -n "$valgrind_only"
Thomas Rast5dfc3682013-06-23 20:12:57 +0200348then
349 test -z "$valgrind" && valgrind=memcheck
350 test -z "$verbose" && verbose_only="$valgrind_only"
351elif test -n "$valgrind"
352then
Jeff King88c6e9d2017-09-05 09:03:54 -0400353 test -z "$verbose_log" && verbose=t
Thomas Rast5dfc3682013-06-23 20:12:57 +0200354fi
Thomas Rast952af352013-03-31 10:00:16 +0200355
Jeff Kingf5ba2de2017-12-08 05:47:17 -0500356if test -n "$trace" && test -z "$verbose_log"
357then
358 verbose=t
359fi
360
Richard Hansenca92a662015-06-17 15:06:25 -0400361if test -n "$color"
362then
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400363 # Save the color control sequences now rather than run tput
364 # each time say_color() is called. This is done for two
365 # reasons:
366 # * TERM will be changed to dumb
367 # * HOME will be changed to a temporary directory and tput
368 # might need to read ~/.terminfo from the original HOME
369 # directory to get the control sequences
370 # Note: This approach assumes the control sequences don't end
371 # in a newline for any terminal of interest (command
372 # substitutions strip trailing newlines). Given that most
373 # (all?) terminals in common use are related to ECMA-48, this
374 # shouldn't be a problem.
375 say_color_error=$(tput bold; tput setaf 1) # bold red
376 say_color_skip=$(tput setaf 4) # blue
377 say_color_warn=$(tput setaf 3) # brown/yellow
378 say_color_pass=$(tput setaf 2) # green
379 say_color_info=$(tput setaf 6) # cyan
380 say_color_reset=$(tput sgr0)
381 say_color_="" # no formatting for normal text
Richard Hansenca92a662015-06-17 15:06:25 -0400382 say_color () {
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400383 test -z "$1" && test -n "$quiet" && return
384 eval "say_color_color=\$say_color_$1"
Richard Hansenca92a662015-06-17 15:06:25 -0400385 shift
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400386 printf "%s\\n" "$say_color_color$*$say_color_reset"
Richard Hansenca92a662015-06-17 15:06:25 -0400387 }
388else
389 say_color() {
390 test -z "$1" && test -n "$quiet" && return
391 shift
392 printf "%s\n" "$*"
393 }
394fi
395
Richard Hansend5c1b7c2015-06-17 17:11:21 -0400396TERM=dumb
397export TERM
398
Pierre Habouzit55db1df2007-10-24 22:03:38 +0200399error () {
400 say_color error "error: $*"
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200401 GIT_EXIT_OK=t
Pierre Habouzit55db1df2007-10-24 22:03:38 +0200402 exit 1
403}
404
SZEDER Gábor165293a2018-11-19 14:13:26 +0100405BUG () {
406 error >&7 "bug in the test script: $*"
407}
408
Pierre Habouzit55db1df2007-10-24 22:03:38 +0200409say () {
410 say_color info "$*"
411}
412
Jeff King614fe012016-10-22 00:45:06 -0400413if test -n "$HARNESS_ACTIVE"
414then
415 if test "$verbose" = t || test -n "$verbose_only"
416 then
417 printf 'Bail out! %s\n' \
418 'verbose mode forbidden under TAP harness; try --verbose-log'
419 exit 1
420 fi
421fi
422
Michele Ballabio570f3222007-11-10 15:17:25 +0100423test "${test_description}" != "" ||
424error "Test script did not set test_description."
425
426if test "$help" = "t"
427then
Uwe Storbeckcb1aefd2014-03-18 01:14:11 +0100428 printf '%s\n' "$test_description"
Michele Ballabio570f3222007-11-10 15:17:25 +0100429 exit 0
430fi
431
Pavel Roskin4d9d62f2005-08-10 23:56:21 -0400432exec 5>&1
Jeff King781f76b2011-12-15 01:55:29 -0500433exec 6<&0
SZEDER Gábor4ecae3c2017-03-18 17:13:59 +0100434exec 7>&2
Jeff King452320f2016-10-21 06:48:00 -0400435if test "$verbose_log" = "t"
436then
437 exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
438elif test "$verbose" = "t"
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700439then
440 exec 4>&2 3>&1
441else
442 exec 4>/dev/null 3>/dev/null
443fi
444
Jeff Kingd88785e2016-05-11 09:44:04 -0400445# Send any "-x" output directly to stderr to avoid polluting tests
446# which capture stderr. We can do this unconditionally since it
447# has no effect if tracing isn't turned on.
448#
449# Note that this sets up the trace fd as soon as we assign the variable, so it
450# must come after the creation of descriptor 4 above. Likewise, we must never
451# unset this, as it has the side effect of closing descriptor 4, which we
452# use to show verbose tests to the user.
453#
454# Note also that we don't need or want to export it. The tracing is local to
455# this shell, and we would not want to influence any shells we exec.
456BASH_XTRACEFD=4
457
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700458test_failure=0
459test_count=0
Junio C Hamano41ac4142008-02-01 01:50:53 -0800460test_fixed=0
461test_broken=0
Sverre Rabbelier2d84e9f2008-06-08 16:04:33 +0200462test_success=0
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700463
Ævar Arnfjörð Bjarmasond998bd42010-06-24 17:44:46 +0000464test_external_has_tap=0
465
Clemens Buchacherfaa4bc32008-02-27 20:28:45 +0100466die () {
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200467 code=$?
468 if test -n "$GIT_EXIT_OK"
469 then
470 exit $code
471 else
472 echo >&5 "FATAL: Unexpected exit with code $code"
473 exit 1
474 fi
Clemens Buchacherfaa4bc32008-02-27 20:28:45 +0100475}
476
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200477GIT_EXIT_OK=
Markus Heidelberg35641312009-01-20 00:43:26 +0100478trap 'die' EXIT
Jeff Kingda706542015-03-13 00:48:48 -0400479trap 'exit $?' INT
Pavel Roskin41184272005-08-11 12:00:40 -0400480
Thomas Rast12a29b12012-02-17 11:25:08 +0100481# The user-facing functions are loaded from a separate file so that
482# test_perf subshells can have them too
Junio C Hamano3c8f12c2012-06-24 22:01:35 -0700483. "$TEST_DIRECTORY/test-lib-functions.sh"
Jonathan Nieder05236a52010-10-17 02:36:58 +0800484
Junio C Hamano886856a2005-05-14 00:24:27 -0700485# You are not expected to call test_ok_ and test_failure_ directly, use
Torstein Hegge3fa36662013-10-27 10:56:33 +0100486# the test_expect_* functions instead.
Junio C Hamano886856a2005-05-14 00:24:27 -0700487
488test_ok_ () {
Johannes Sixtd5d9de12009-02-05 20:59:27 +0100489 test_success=$(($test_success + 1))
Thomas Rast633fe502013-10-19 23:06:08 +0200490 say_color "" "ok $test_count - $@"
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700491}
492
Junio C Hamano886856a2005-05-14 00:24:27 -0700493test_failure_ () {
Johannes Sixtd5d9de12009-02-05 20:59:27 +0100494 test_failure=$(($test_failure + 1))
Thomas Rast633fe502013-10-19 23:06:08 +0200495 say_color error "not ok $test_count - $1"
Junio C Hamanobf0dd8a2005-07-22 19:09:34 -0700496 shift
Uwe Storbeckcb1aefd2014-03-18 01:14:11 +0100497 printf '%s\n' "$*" | sed -e 's/^/# /'
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200498 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
Junio C Hamano886856a2005-05-14 00:24:27 -0700499}
500
Junio C Hamano41ac4142008-02-01 01:50:53 -0800501test_known_broken_ok_ () {
Junio C Hamano41ac4142008-02-01 01:50:53 -0800502 test_fixed=$(($test_fixed+1))
Thomas Rast633fe502013-10-19 23:06:08 +0200503 say_color error "ok $test_count - $@ # TODO known breakage vanished"
Junio C Hamano41ac4142008-02-01 01:50:53 -0800504}
505
506test_known_broken_failure_ () {
Junio C Hamano41ac4142008-02-01 01:50:53 -0800507 test_broken=$(($test_broken+1))
Thomas Rast633fe502013-10-19 23:06:08 +0200508 say_color warn "not ok $test_count - $@ # TODO known breakage"
Junio C Hamano41ac4142008-02-01 01:50:53 -0800509}
Junio C Hamano886856a2005-05-14 00:24:27 -0700510
511test_debug () {
Junio C Hamano8e832eb2005-08-10 22:53:27 -0700512 test "$debug" = "" || eval "$1"
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700513}
514
Thomas Raste6a6ddc2013-06-18 14:25:58 +0200515match_pattern_list () {
516 arg="$1"
517 shift
518 test -z "$*" && return 1
519 for pattern_
520 do
521 case "$arg" in
522 $pattern_)
523 return 0
524 esac
525 done
526 return 1
527}
528
Ilya Bobyr0445e6f2014-04-30 02:50:44 -0700529match_test_selector_list () {
530 title="$1"
531 shift
532 arg="$1"
533 shift
534 test -z "$1" && return 0
535
536 # Both commas and whitespace are accepted as separators.
537 OLDIFS=$IFS
538 IFS=' ,'
539 set -- $1
540 IFS=$OLDIFS
541
542 # If the first selector is negative we include by default.
543 include=
544 case "$1" in
545 !*) include=t ;;
546 esac
547
548 for selector
549 do
550 orig_selector=$selector
551
552 positive=t
553 case "$selector" in
554 !*)
555 positive=
556 selector=${selector##?}
557 ;;
558 esac
559
560 test -z "$selector" && continue
561
562 case "$selector" in
563 *-*)
564 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
565 then
566 echo "error: $title: invalid non-numeric in range" \
567 "start: '$orig_selector'" >&2
568 exit 1
569 fi
570 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
571 then
572 echo "error: $title: invalid non-numeric in range" \
573 "end: '$orig_selector'" >&2
574 exit 1
575 fi
576 ;;
577 *)
578 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
579 then
580 echo "error: $title: invalid non-numeric in test" \
581 "selector: '$orig_selector'" >&2
582 exit 1
583 fi
584 esac
585
586 # Short cut for "obvious" cases
587 test -z "$include" && test -z "$positive" && continue
588 test -n "$include" && test -n "$positive" && continue
589
590 case "$selector" in
591 -*)
592 if test $arg -le ${selector#-}
593 then
594 include=$positive
595 fi
596 ;;
597 *-)
598 if test $arg -ge ${selector%-}
599 then
600 include=$positive
601 fi
602 ;;
603 *-*)
604 if test ${selector%%-*} -le $arg \
605 && test $arg -le ${selector#*-}
606 then
607 include=$positive
608 fi
609 ;;
610 *)
611 if test $arg -eq $selector
612 then
613 include=$positive
614 fi
615 ;;
616 esac
617 done
618
619 test -n "$include"
620}
621
Thomas Rastff09af32013-06-23 20:12:56 +0200622maybe_teardown_verbose () {
623 test -z "$verbose_only" && return
624 exec 4>/dev/null 3>/dev/null
625 verbose=
626}
627
628last_verbose=t
629maybe_setup_verbose () {
630 test -z "$verbose_only" && return
Thomas Rast26a07302013-10-19 23:06:07 +0200631 if match_pattern_list $test_count $verbose_only
Thomas Rastff09af32013-06-23 20:12:56 +0200632 then
633 exec 4>&2 3>&1
634 # Emit a delimiting blank line when going from
635 # non-verbose to verbose. Within verbose mode the
636 # delimiter is printed by test_expect_*. The choice
637 # of the initial $last_verbose is such that before
638 # test 1, we do not print it.
639 test -z "$last_verbose" && echo >&3 ""
640 verbose=t
641 else
642 exec 4>/dev/null 3>/dev/null
643 verbose=
644 fi
645 last_verbose=$verbose
646}
647
Thomas Rast5dfc3682013-06-23 20:12:57 +0200648maybe_teardown_valgrind () {
649 test -z "$GIT_VALGRIND" && return
650 GIT_VALGRIND_ENABLED=
651}
652
653maybe_setup_valgrind () {
654 test -z "$GIT_VALGRIND" && return
Thomas Rast26a07302013-10-19 23:06:07 +0200655 if test -z "$valgrind_only"
Thomas Rast5dfc3682013-06-23 20:12:57 +0200656 then
657 GIT_VALGRIND_ENABLED=t
658 return
659 fi
660 GIT_VALGRIND_ENABLED=
661 if match_pattern_list $test_count $valgrind_only
662 then
663 GIT_VALGRIND_ENABLED=t
664 fi
665}
666
Jeff King9b5fe782015-08-06 01:33:57 -0400667want_trace () {
Jeff Kingf5ba2de2017-12-08 05:47:17 -0500668 test "$trace" = t && {
669 test "$verbose" = t || test "$verbose_log" = t
670 }
Jeff King9b5fe782015-08-06 01:33:57 -0400671}
672
Jeff Kinga136f6d2014-10-10 02:47:27 -0400673# This is a separate function because some tests use
674# "return" to end a test_expect_success block early
675# (and we want to make sure we run any cleanup like
676# "set +x").
677test_eval_inner_ () {
678 # Do not add anything extra (including LF) after '$*'
679 eval "
Jeff King9b5fe782015-08-06 01:33:57 -0400680 want_trace && set -x
Jeff Kinga136f6d2014-10-10 02:47:27 -0400681 $*"
682}
683
Jonathan Niedera7c58f22011-08-08 03:17:09 +0200684test_eval_ () {
Jeff King90c8a1d2017-12-08 05:47:08 -0500685 # If "-x" tracing is in effect, then we want to avoid polluting stderr
686 # with non-test commands. But once in "set -x" mode, we cannot prevent
Jeff Kinga136f6d2014-10-10 02:47:27 -0400687 # the shell from printing the "set +x" to turn it off (nor the saving
688 # of $? before that). But we can make sure that the output goes to
689 # /dev/null.
690 #
Jeff King90c8a1d2017-12-08 05:47:08 -0500691 # There are a few subtleties here:
692 #
693 # - we have to redirect descriptor 4 in addition to 2, to cover
694 # BASH_XTRACEFD
695 #
696 # - the actual eval has to come before the redirection block (since
697 # it needs to see descriptor 4 to set up its stderr)
698 #
699 # - likewise, any error message we print must be outside the block to
700 # access descriptor 4
701 #
702 # - checking $? has to come immediately after the eval, but it must
703 # be _inside_ the block to avoid polluting the "set -x" output
704 #
705
706 test_eval_inner_ "$@" </dev/null >&3 2>&4
Jeff Kinga136f6d2014-10-10 02:47:27 -0400707 {
Jeff Kinga136f6d2014-10-10 02:47:27 -0400708 test_eval_ret_=$?
Jeff King9b5fe782015-08-06 01:33:57 -0400709 if want_trace
Jeff Kinga136f6d2014-10-10 02:47:27 -0400710 then
711 set +x
Jeff Kinga136f6d2014-10-10 02:47:27 -0400712 fi
Jeff King90c8a1d2017-12-08 05:47:08 -0500713 } 2>/dev/null 4>&2
714
715 if test "$test_eval_ret_" != 0 && want_trace
716 then
717 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
718 fi
Jeff Kinga136f6d2014-10-10 02:47:27 -0400719 return $test_eval_ret_
Jonathan Niedera7c58f22011-08-08 03:17:09 +0200720}
721
Pavel Roskin4d9d62f2005-08-10 23:56:21 -0400722test_run_ () {
Jonathan Niederb6b0afd2010-05-06 03:41:10 -0500723 test_cleanup=:
Junio C Hamanob5867442011-06-27 11:02:22 -0700724 expecting_failure=$2
Jeff Kingbb79af92015-03-20 06:05:48 -0400725
Jeff King92b269f2015-04-22 16:09:57 -0400726 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
Jeff King2a01ef82015-08-06 01:31:47 -0400727 # turn off tracing for this test-eval, as it simply creates
728 # confusing noise in the "-x" output
729 trace_tmp=$trace
730 trace=
Jeff Kingbb79af92015-03-20 06:05:48 -0400731 # 117 is magic because it is unlikely to match the exit
732 # code of other programs
Eric Sunshine878f9882018-07-11 02:46:33 -0400733 if $(printf '%s\n' "$1" | sed -f "$GIT_BUILD_DIR/t/chainlint.sed" | grep -q '?![A-Z][A-Z]*?!') ||
734 test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)"
Junio C Hamano99a64e42017-03-22 22:43:18 -0700735 then
SZEDER Gábor165293a2018-11-19 14:13:26 +0100736 BUG "broken &&-chain or run-away HERE-DOC: $1"
Jeff Kingbb79af92015-03-20 06:05:48 -0400737 fi
Jeff King2a01ef82015-08-06 01:31:47 -0400738 trace=$trace_tmp
Jeff Kingbb79af92015-03-20 06:05:48 -0400739 fi
740
Thomas Rasta57397b2013-06-17 11:18:46 +0200741 setup_malloc_check
Jonathan Niedera7c58f22011-08-08 03:17:09 +0200742 test_eval_ "$1"
Jonathan Niederb6b0afd2010-05-06 03:41:10 -0500743 eval_ret=$?
Thomas Rasta57397b2013-06-17 11:18:46 +0200744 teardown_malloc_check
Junio C Hamanob5867442011-06-27 11:02:22 -0700745
Jeff Kinga136f6d2014-10-10 02:47:27 -0400746 if test -z "$immediate" || test $eval_ret = 0 ||
747 test -n "$expecting_failure" && test "$test_cleanup" != ":"
Junio C Hamanob5867442011-06-27 11:02:22 -0700748 then
Junio C Hamano1b3185f2012-09-14 20:38:24 -0700749 setup_malloc_check
Jonathan Niedera7c58f22011-08-08 03:17:09 +0200750 test_eval_ "$test_cleanup"
Junio C Hamano1b3185f2012-09-14 20:38:24 -0700751 teardown_malloc_check
Junio C Hamanob5867442011-06-27 11:02:22 -0700752 fi
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100753 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
754 then
Ævar Arnfjörð Bjarmason57e15382010-06-24 17:44:47 +0000755 echo ""
756 fi
Jonathan Niederaa0bcf92011-08-08 03:15:34 +0200757 return "$eval_ret"
Pavel Roskin4d9d62f2005-08-10 23:56:21 -0400758}
759
Thomas Rastae753422013-06-18 14:25:59 +0200760test_start_ () {
Johannes Sixt8586f982009-02-05 21:20:56 +0100761 test_count=$(($test_count+1))
Thomas Rastff09af32013-06-23 20:12:56 +0200762 maybe_setup_verbose
Thomas Rast5dfc3682013-06-23 20:12:57 +0200763 maybe_setup_valgrind
Thomas Rastae753422013-06-18 14:25:59 +0200764}
765
766test_finish_ () {
767 echo >&3 ""
Thomas Rast5dfc3682013-06-23 20:12:57 +0200768 maybe_teardown_valgrind
Thomas Rastff09af32013-06-23 20:12:56 +0200769 maybe_teardown_verbose
Thomas Rastae753422013-06-18 14:25:59 +0200770}
771
772test_skip () {
Junio C Hamano04ece592006-12-28 17:58:00 -0800773 to_skip=
Ilya Bobyref2ac682014-04-30 02:50:43 -0700774 skipped_reason=
Thomas Raste6a6ddc2013-06-18 14:25:58 +0200775 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
776 then
777 to_skip=t
Ilya Bobyref2ac682014-04-30 02:50:43 -0700778 skipped_reason="GIT_SKIP_TESTS"
Thomas Raste6a6ddc2013-06-18 14:25:58 +0200779 fi
Jonathan Nieder05236a52010-10-17 02:36:58 +0800780 if test -z "$to_skip" && test -n "$test_prereq" &&
781 ! test_have_prereq "$test_prereq"
Johannes Sixta7bb3942009-03-01 21:04:46 +0100782 then
783 to_skip=t
Ilya Bobyref2ac682014-04-30 02:50:43 -0700784
Jonathan Nieder07431fc2010-08-24 02:34:10 -0500785 of_prereq=
Jonathan Nieder05236a52010-10-17 02:36:58 +0800786 if test "$missing_prereq" != "$test_prereq"
Jonathan Nieder07431fc2010-08-24 02:34:10 -0500787 then
Jonathan Nieder05236a52010-10-17 02:36:58 +0800788 of_prereq=" of $test_prereq"
Jonathan Nieder07431fc2010-08-24 02:34:10 -0500789 fi
Ilya Bobyref2ac682014-04-30 02:50:43 -0700790 skipped_reason="missing $missing_prereq${of_prereq}"
791 fi
Ilya Bobyr0445e6f2014-04-30 02:50:44 -0700792 if test -z "$to_skip" && test -n "$run_list" &&
793 ! match_test_selector_list '--run' $test_count "$run_list"
794 then
795 to_skip=t
796 skipped_reason="--run"
797 fi
Jonathan Nieder07431fc2010-08-24 02:34:10 -0500798
Ilya Bobyref2ac682014-04-30 02:50:43 -0700799 case "$to_skip" in
800 t)
Thomas Rast633fe502013-10-19 23:06:08 +0200801 say_color skip >&3 "skipping test: $@"
Ilya Bobyref2ac682014-04-30 02:50:43 -0700802 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
Junio C Hamano04ece592006-12-28 17:58:00 -0800803 : true
804 ;;
805 *)
806 false
807 ;;
808 esac
809}
810
Thomas Rast342e9ef2012-02-17 11:25:09 +0100811# stub; perf-lib overrides it
812test_at_end_hook_ () {
813 :
814}
815
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700816test_done () {
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +0200817 GIT_EXIT_OK=t
Sverre Rabbelier2d84e9f2008-06-08 16:04:33 +0200818
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100819 if test -z "$HARNESS_ACTIVE"
820 then
Thomas Rast342e9ef2012-02-17 11:25:09 +0100821 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
Ævar Arnfjörð Bjarmason8ef1abe2010-08-11 19:37:31 +0000822 mkdir -p "$test_results_dir"
Felipe Contrerasdd784782012-11-04 03:13:33 +0100823 base=${0##*/}
Jeff King5c885c12016-08-30 04:43:57 -0400824 test_results_path="$test_results_dir/${base%.sh}.counts"
Ævar Arnfjörð Bjarmason8ef1abe2010-08-11 19:37:31 +0000825
Jeff King5c885c12016-08-30 04:43:57 -0400826 cat >"$test_results_path" <<-EOF
Mathias Lafeldtc54e6be2011-04-29 14:30:30 +0200827 total $test_count
828 success $test_success
829 fixed $test_fixed
830 broken $test_broken
831 failed $test_failure
832
833 EOF
Ævar Arnfjörð Bjarmason8ef1abe2010-08-11 19:37:31 +0000834 fi
Junio C Hamano41ac4142008-02-01 01:50:53 -0800835
836 if test "$test_fixed" != 0
837 then
Thomas Rast633fe502013-10-19 23:06:08 +0200838 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
Junio C Hamano41ac4142008-02-01 01:50:53 -0800839 fi
840 if test "$test_broken" != 0
841 then
Thomas Rast633fe502013-10-19 23:06:08 +0200842 say_color warn "# still have $test_broken known breakage(s)"
Adam Spiersb73d9a22012-12-16 18:28:15 +0000843 fi
844 if test "$test_broken" != 0 || test "$test_fixed" != 0
845 then
846 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
847 msg="remaining $test_remaining test(s)"
Junio C Hamano11d54b82008-02-03 00:23:02 -0800848 else
Adam Spiersb73d9a22012-12-16 18:28:15 +0000849 test_remaining=$test_count
Junio C Hamano11d54b82008-02-03 00:23:02 -0800850 msg="$test_count test(s)"
Junio C Hamano41ac4142008-02-01 01:50:53 -0800851 fi
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700852 case "$test_failure" in
Junio C Hamano10b94e22005-12-09 17:32:18 -0800853 0)
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100854 if test $test_external_has_tap -eq 0
855 then
Adam Spiersb73d9a22012-12-16 18:28:15 +0000856 if test $test_remaining -gt 0
Ramsay Jonesd87bd7c2012-09-01 19:26:21 +0100857 then
Thomas Rast633fe502013-10-19 23:06:08 +0200858 say_color pass "# passed all $msg"
Ramsay Jonesd87bd7c2012-09-01 19:26:21 +0100859 fi
Junio C Hamanoc7018be2017-05-18 11:52:20 +0900860
861 # Maybe print SKIP message
862 test -z "$skip_all" || skip_all="# SKIP $skip_all"
863 case "$test_count" in
864 0)
865 say "1..$test_count${skip_all:+ $skip_all}"
866 ;;
867 *)
868 test -z "$skip_all" ||
869 say_color warn "$skip_all"
870 say "1..$test_count"
871 ;;
872 esac
Ævar Arnfjörð Bjarmasond998bd42010-06-24 17:44:46 +0000873 fi
Johannes Schindelinabc5d372008-08-08 13:08:37 +0200874
Junio C Hamano06478da2017-04-23 17:15:09 -0700875 if test -z "$debug"
Junio C Hamano4d0912a2017-04-24 23:39:47 -0700876 then
Junio C Hamano06478da2017-04-23 17:15:09 -0700877 test -d "$TRASH_DIRECTORY" ||
Junio C Hamano4d0912a2017-04-24 23:39:47 -0700878 error "Tests passed but trash directory already removed before test cleanup; aborting"
Johannes Schindelinabc5d372008-08-08 13:08:37 +0200879
Junio C Hamano06478da2017-04-23 17:15:09 -0700880 cd "$TRASH_DIRECTORY/.." &&
881 rm -fr "$TRASH_DIRECTORY" ||
Junio C Hamano4d0912a2017-04-24 23:39:47 -0700882 error "Tests passed but test cleanup failed; aborting"
Junio C Hamano4d0912a2017-04-24 23:39:47 -0700883 fi
Thomas Rast342e9ef2012-02-17 11:25:09 +0100884 test_at_end_hook_
885
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700886 exit 0 ;;
887
888 *)
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100889 if test $test_external_has_tap -eq 0
890 then
Thomas Rast633fe502013-10-19 23:06:08 +0200891 say_color error "# failed $test_failure among $msg"
892 say "1..$test_count"
Ævar Arnfjörð Bjarmasond998bd42010-06-24 17:44:46 +0000893 fi
Ævar Arnfjörð Bjarmason5099b992010-06-24 21:52:12 +0000894
Junio C Hamanoe1970ce2005-05-13 22:50:32 -0700895 exit 1 ;;
896
897 esac
898}
899
Matthew Ogilviee4597aa2009-12-02 22:14:06 -0700900if test -n "$valgrind"
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100901then
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100902 make_symlink () {
903 test -h "$2" &&
904 test "$1" = "$(readlink "$2")" || {
905 # be super paranoid
906 if mkdir "$2".lock
907 then
908 rm -f "$2" &&
909 ln -s "$1" "$2" &&
910 rm -r "$2".lock
911 else
912 while test -d "$2".lock
913 do
914 say "Waiting for lock on $2."
915 sleep 1
916 done
917 fi
918 }
919 }
920
921 make_valgrind_symlink () {
Jeff King36bfb0e2011-06-17 16:36:32 -0400922 # handle only executables, unless they are shell libraries that
Jonathan Nieder11d62142013-11-25 13:03:52 -0800923 # need to be in the exec-path.
Jeff King36bfb0e2011-06-17 16:36:32 -0400924 test -x "$1" ||
Ævar Arnfjörð Bjarmason2a59a6e2018-08-24 15:20:11 +0000925 test "# " = "$(test_copy_bytes 2 <"$1")" ||
Jeff King36bfb0e2011-06-17 16:36:32 -0400926 return;
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100927
928 base=$(basename "$1")
René Scharfe28fab7b2016-10-28 00:14:00 +0200929 case "$base" in
930 test-*)
931 symlink_target="$GIT_BUILD_DIR/t/helper/$base"
932 ;;
933 *)
934 symlink_target="$GIT_BUILD_DIR/$base"
935 ;;
936 esac
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100937 # do not override scripts
938 if test -x "$symlink_target" &&
939 test ! -d "$symlink_target" &&
Ævar Arnfjörð Bjarmason2a59a6e2018-08-24 15:20:11 +0000940 test "#!" != "$(test_copy_bytes 2 <"$symlink_target")"
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100941 then
942 symlink_target=../valgrind.sh
943 fi
Johannes Schindelinefd92ff2009-02-04 00:26:08 +0100944 case "$base" in
945 *.sh|*.perl)
946 symlink_target=../unprocessed-script
947 esac
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100948 # create the link, or replace it if it is out of date
949 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
950 }
951
Thomas Rast26a07302013-10-19 23:06:07 +0200952 # override all git executables in TEST_DIRECTORY/..
953 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
954 mkdir -p "$GIT_VALGRIND"/bin
Johannes Schindelin503e2242016-07-11 13:45:08 +0200955 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
Thomas Rast26a07302013-10-19 23:06:07 +0200956 do
957 make_valgrind_symlink $file
958 done
959 # special-case the mergetools loadables
960 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
961 OLDIFS=$IFS
962 IFS=:
963 for path in $PATH
964 do
965 ls "$path"/git-* 2> /dev/null |
966 while read file
Johannes Schindelinefd92ff2009-02-04 00:26:08 +0100967 do
Thomas Rast26a07302013-10-19 23:06:07 +0200968 make_valgrind_symlink "$file"
Johannes Schindelinefd92ff2009-02-04 00:26:08 +0100969 done
Thomas Rast26a07302013-10-19 23:06:07 +0200970 done
971 IFS=$OLDIFS
Johannes Schindelin4e1be632009-02-04 00:25:59 +0100972 PATH=$GIT_VALGRIND/bin:$PATH
973 GIT_EXEC_PATH=$GIT_VALGRIND/bin
974 export GIT_VALGRIND
Thomas Rast952af352013-03-31 10:00:16 +0200975 GIT_VALGRIND_MODE="$valgrind"
976 export GIT_VALGRIND_MODE
Thomas Rast5dfc3682013-06-23 20:12:57 +0200977 GIT_VALGRIND_ENABLED=t
Thomas Rast26a07302013-10-19 23:06:07 +0200978 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
Thomas Rast5dfc3682013-06-23 20:12:57 +0200979 export GIT_VALGRIND_ENABLED
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100980elif test -n "$GIT_TEST_INSTALLED"
981then
Matthew Ogilviee4597aa2009-12-02 22:14:06 -0700982 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
983 error "Cannot run git from $GIT_TEST_INSTALLED."
Johannes Schindelin16df35c2018-11-12 05:48:33 -0800984 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR/t/helper:$PATH
Matthew Ogilviee4597aa2009-12-02 22:14:06 -0700985 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
986else # normal case, use ../bin-wrappers only unless $with_dashes:
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000987 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100988 if ! test -x "$git_bin_dir/git"
989 then
990 if test -z "$with_dashes"
991 then
Matthew Ogilviee4597aa2009-12-02 22:14:06 -0700992 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
993 fi
994 with_dashes=t
995 fi
996 PATH="$git_bin_dir:$PATH"
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +0000997 GIT_EXEC_PATH=$GIT_BUILD_DIR
Ramsay Jones1c0cc752012-09-01 19:11:49 +0100998 if test -n "$with_dashes"
999 then
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +00001000 PATH="$GIT_BUILD_DIR:$PATH"
Matthew Ogilviee4597aa2009-12-02 22:14:06 -07001001 fi
Johannes Schindelin4e1be632009-02-04 00:25:59 +01001002fi
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +00001003GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
Jeff King8bfa6bd2008-02-06 05:11:53 -05001004GIT_CONFIG_NOSYSTEM=1
Jonathan Nieder3c995be2011-03-15 04:05:10 -05001005GIT_ATTR_NOSYSTEM=1
Jonathan Nieder8f323c02011-03-15 04:04:49 -05001006export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
Junio C Hamano49ccb082005-12-07 21:52:28 -08001007
Junio C Hamano5e87eae2010-06-11 09:40:25 -07001008if test -z "$GIT_TEST_CMP"
1009then
1010 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1011 then
1012 GIT_TEST_CMP="$DIFF -c"
1013 else
1014 GIT_TEST_CMP="$DIFF -u"
1015 fi
1016fi
1017
Ævar Arnfjörð Bjarmason20d2a302017-12-10 21:13:33 +00001018GITPERLLIB="$GIT_BUILD_DIR"/perl/build/lib
Petr Baudis6fcca932006-07-03 23:16:32 +02001019export GITPERLLIB
Ævar Arnfjörð Bjarmason6cec5c62010-08-19 16:08:10 +00001020test -d "$GIT_BUILD_DIR"/templates/blt || {
Junio C Hamanoeea42062005-12-10 20:55:32 -08001021 error "You haven't built things yet, have you?"
1022}
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07001023
Nguyễn Thái Ngọc Duy0e496492018-03-24 08:44:31 +01001024if ! test -x "$GIT_BUILD_DIR"/t/helper/test-tool
Ramsay Jones1c0cc752012-09-01 19:11:49 +01001025then
Nguyễn Thái Ngọc Duy0e496492018-03-24 08:44:31 +01001026 echo >&2 'You need to build test-tool:'
1027 echo >&2 'Run "make t/helper/test-tool" in the source (toplevel) directory'
Eric Wong56cf9802007-02-24 16:59:52 -08001028 exit 1
1029fi
1030
Junio C Hamanoe1970ce2005-05-13 22:50:32 -07001031# Test repository
Jeff King002d4ce2013-04-14 15:38:21 -04001032TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
1033test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
1034case "$TRASH_DIRECTORY" in
1035/*) ;; # absolute path is good
1036 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
Jeff Kingf423ef52009-08-09 04:39:45 -04001037esac
John Keeping38b074d2013-04-14 17:34:56 +01001038rm -fr "$TRASH_DIRECTORY" || {
Clemens Buchacher6e7b5aa2009-06-01 14:14:41 +02001039 GIT_EXIT_OK=t
Junio C Hamano8d14ac92008-03-18 21:58:01 -07001040 echo >&5 "FATAL: Cannot prepare test area"
1041 exit 1
1042}
1043
Alex Riesen90cff962011-03-26 19:46:34 +01001044HOME="$TRASH_DIRECTORY"
Junio C Hamano0ea47f92014-09-15 14:59:00 -07001045GNUPGHOME="$HOME/gnupg-home-not-used"
1046export HOME GNUPGHOME
Alex Riesen90cff962011-03-26 19:46:34 +01001047
Ramsay Jones1c0cc752012-09-01 19:11:49 +01001048if test -z "$TEST_NO_CREATE_REPO"
1049then
John Keeping38b074d2013-04-14 17:34:56 +01001050 test_create_repo "$TRASH_DIRECTORY"
Thomas Rast342e9ef2012-02-17 11:25:09 +01001051else
John Keeping38b074d2013-04-14 17:34:56 +01001052 mkdir -p "$TRASH_DIRECTORY"
Thomas Rast342e9ef2012-02-17 11:25:09 +01001053fi
Lea Wiemann1bd9c642008-05-31 23:11:21 +02001054# Use -P to resolve symlinks in our working directory so that the cwd
1055# in subprocesses like git equals our $PWD (for pathname comparisons).
John Keeping38b074d2013-04-14 17:34:56 +01001056cd -P "$TRASH_DIRECTORY" || exit 1
Junio C Hamano04ece592006-12-28 17:58:00 -08001057
Johannes Sixtd5d9de12009-02-05 20:59:27 +01001058this_test=${0##*/}
1059this_test=${this_test%%-*}
Thomas Raste6a6ddc2013-06-18 14:25:58 +02001060if match_pattern_list "$this_test" $GIT_SKIP_TESTS
1061then
1062 say_color info >&3 "skipping test $this_test altogether"
1063 skip_all="skip all tests in $this_test"
1064 test_done
1065fi
Johannes Sixtf17e9fb2009-03-11 21:17:26 +01001066
Brandon Casey86487322009-08-28 17:32:41 -05001067# Provide an implementation of the 'yes' utility
1068yes () {
1069 if test $# = 0
1070 then
1071 y=y
1072 else
1073 y="$*"
1074 fi
1075
Johannes Schindelin6129c932016-02-02 19:15:53 +01001076 i=0
1077 while test $i -lt 99
Brandon Casey86487322009-08-28 17:32:41 -05001078 do
Johannes Schindelin6129c932016-02-02 19:15:53 +01001079 echo "$y"
1080 i=$(($i+1))
Brandon Casey86487322009-08-28 17:32:41 -05001081 done
1082}
1083
Johannes Sixtf17e9fb2009-03-11 21:17:26 +01001084# Fix some commands on Windows
Johannes Schindelind98b2c52016-07-21 18:02:54 +02001085uname_s=$(uname -s)
1086case $uname_s in
Johannes Sixtf17e9fb2009-03-11 21:17:26 +01001087*MINGW*)
1088 # Windows has its own (incompatible) sort and find
1089 sort () {
1090 /usr/bin/sort "$@"
1091 }
1092 find () {
1093 /usr/bin/find "$@"
1094 }
Johannes Sixt41141562009-03-13 23:35:24 +01001095 # git sees Windows-style pwd
1096 pwd () {
1097 builtin pwd -W
1098 }
Johannes Sixtee9fb682009-03-13 22:55:27 +01001099 # no POSIX permissions
Johannes Sixt6fd11062009-03-13 23:00:15 +01001100 # backslashes in pathspec are converted to '/'
Johannes Sixtfb9a2be2009-03-25 13:21:15 +01001101 # exec does not inherit the PID
Pat Thoytsa94114a2010-09-12 10:37:24 +01001102 test_set_prereq MINGW
Brice Lambson5f4e02e2014-08-30 23:39:07 +02001103 test_set_prereq NATIVE_CRLF
Ramsay Jonesa31d0662010-12-14 18:32:12 +00001104 test_set_prereq SED_STRIPS_CR
Mark Levedahl97669ee2013-07-18 17:44:57 -04001105 test_set_prereq GREP_STRIPS_CR
Johannes Sixt4d715ac2013-10-26 21:17:15 +02001106 GIT_TEST_CMP=mingw_test_cmp
Ramsay Jonesa31d0662010-12-14 18:32:12 +00001107 ;;
1108*CYGWIN*)
1109 test_set_prereq POSIXPERM
Ramsay Jonesa31d0662010-12-14 18:32:12 +00001110 test_set_prereq EXECKEEPSPID
Pete Wyckoffcfa96492013-01-26 22:11:11 -05001111 test_set_prereq CYGWIN
Ramsay Jonesa31d0662010-12-14 18:32:12 +00001112 test_set_prereq SED_STRIPS_CR
Mark Levedahl97669ee2013-07-18 17:44:57 -04001113 test_set_prereq GREP_STRIPS_CR
Johannes Sixtee9fb682009-03-13 22:55:27 +01001114 ;;
1115*)
1116 test_set_prereq POSIXPERM
Johannes Sixt6fd11062009-03-13 23:00:15 +01001117 test_set_prereq BSLASHPSPEC
Johannes Sixtfb9a2be2009-03-25 13:21:15 +01001118 test_set_prereq EXECKEEPSPID
Johannes Sixtf17e9fb2009-03-11 21:17:26 +01001119 ;;
1120esac
Johannes Sixt704a3142009-03-04 22:38:24 +01001121
Zbigniew Jędrzejewski-Szmekb0826872012-04-27 11:25:25 +02001122( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
Jeff King1b19ccd2009-04-03 15:33:59 -04001123test -z "$NO_PERL" && test_set_prereq PERL
Ævar Arnfjörð Bjarmason68c7d272017-05-25 19:45:31 +00001124test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
Johan Herlandd4e1b472009-11-18 02:42:31 +01001125test -z "$NO_PYTHON" && test_set_prereq PYTHON
Ævar Arnfjörð Bjarmason94da9192017-06-01 18:20:56 +00001126test -n "$USE_LIBPCRE1$USE_LIBPCRE2" && test_set_prereq PCRE
Ævar Arnfjörð Bjarmasonce9a2572017-11-23 14:16:57 +00001127test -n "$USE_LIBPCRE1" && test_set_prereq LIBPCRE1
1128test -n "$USE_LIBPCRE2" && test_set_prereq LIBPCRE2
Ævar Arnfjörð Bjarmason5e9637c2011-11-18 00:14:42 +01001129test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
Jeff King1b19ccd2009-04-03 15:33:59 -04001130
Ævar Arnfjörð Bjarmason6cdccfc2018-11-08 21:15:29 +00001131if test -n "$GIT_TEST_GETTEXT_POISON_ORIG"
Jonathan Nieder30955222011-02-22 23:41:22 +00001132then
Ævar Arnfjörð Bjarmason6cdccfc2018-11-08 21:15:29 +00001133 GIT_TEST_GETTEXT_POISON=$GIT_TEST_GETTEXT_POISON_ORIG
Junio C Hamanof88b9cb2019-04-15 13:48:31 +09001134 export GIT_TEST_GETTEXT_POISON
Ævar Arnfjörð Bjarmason6cdccfc2018-11-08 21:15:29 +00001135 unset GIT_TEST_GETTEXT_POISON_ORIG
1136fi
1137
1138# Can we rely on git's output in the C locale?
1139if test -z "$GIT_TEST_GETTEXT_POISON"
1140then
Jonathan Nieder30955222011-02-22 23:41:22 +00001141 test_set_prereq C_LOCALE_OUTPUT
1142fi
Ævar Arnfjörð Bjarmasonbb946bb2011-02-22 23:41:21 +00001143
Nguyễn Thái Ngọc Duy4592e602018-08-18 16:41:28 +02001144if test -z "$GIT_TEST_CHECK_CACHE_TREE"
1145then
1146 GIT_TEST_CHECK_CACHE_TREE=true
1147 export GIT_TEST_CHECK_CACHE_TREE
1148fi
1149
Adam Spiers20073272013-04-11 03:07:04 +01001150test_lazy_prereq PIPE '
1151 # test whether the filesystem supports FIFOs
Ramsay Jones7b7bea22017-09-17 23:56:00 +01001152 test_have_prereq !MINGW,!CYGWIN &&
1153 rm -f testfifo && mkfifo testfifo
Adam Spiers20073272013-04-11 03:07:04 +01001154'
1155
Junio C Hamano04083f22012-07-26 15:50:45 -07001156test_lazy_prereq SYMLINKS '
1157 # test whether the filesystem supports symbolic links
1158 ln -s x y && test -h y
1159'
Ævar Arnfjörð Bjarmasonc91cfd12010-08-06 22:09:09 +00001160
Jonathan Niederb018c732013-11-25 13:02:16 -08001161test_lazy_prereq FILEMODE '
1162 test "$(git config --bool core.filemode)" = true
1163'
1164
Michael J Gruberac39aa62012-07-26 15:39:53 +02001165test_lazy_prereq CASE_INSENSITIVE_FS '
1166 echo good >CamelCase &&
1167 echo bad >camelcase &&
1168 test "$(cat CamelCase)" != good
1169'
1170
William Chargin6ec63302018-08-06 11:35:08 -07001171test_lazy_prereq FUNNYNAMES '
1172 test_have_prereq !MINGW &&
1173 touch -- \
1174 "FUNNYNAMES tab embedded" \
1175 "FUNNYNAMES \"quote embedded\"" \
1176 "FUNNYNAMES newline
1177embedded" 2>/dev/null &&
1178 rm -- \
1179 "FUNNYNAMES tab embedded" \
1180 "FUNNYNAMES \"quote embedded\"" \
1181 "FUNNYNAMES newline
1182embedded" 2>/dev/null
1183'
1184
Michael J Gruber5b0b5dd2012-07-26 15:39:56 +02001185test_lazy_prereq UTF8_NFD_TO_NFC '
1186 # check whether FS converts nfd unicode to nfc
1187 auml=$(printf "\303\244")
1188 aumlcdiar=$(printf "\141\314\210")
1189 >"$auml" &&
Torsten Bögershausen742ae102018-04-30 08:35:19 +02001190 test -f "$aumlcdiar"
Michael J Gruber5b0b5dd2012-07-26 15:39:56 +02001191'
1192
Jeff King09feffb2012-11-14 16:33:40 -08001193test_lazy_prereq AUTOIDENT '
1194 sane_unset GIT_AUTHOR_NAME &&
1195 sane_unset GIT_AUTHOR_EMAIL &&
1196 git var GIT_AUTHOR_IDENT
1197'
1198
Junio C Hamano6219bb22014-06-09 12:23:30 -07001199test_lazy_prereq EXPENSIVE '
1200 test -n "$GIT_TEST_LONG"
1201'
1202
Ævar Arnfjörð Bjarmason5b1fe6e2018-01-30 21:21:23 +00001203test_lazy_prereq EXPENSIVE_ON_WINDOWS '
1204 test_have_prereq EXPENSIVE || test_have_prereq !MINGW,!CYGWIN
1205'
1206
Junio C Hamanoe1ecd9e2014-06-09 13:54:25 -07001207test_lazy_prereq USR_BIN_TIME '
1208 test -x /usr/bin/time
1209'
1210
Jeff King1767c512015-01-16 04:16:49 -05001211test_lazy_prereq NOT_ROOT '
1212 uid=$(id -u) &&
1213 test "$uid" != 0
1214'
1215
Jonathan Tan63b747c2016-09-09 10:36:28 -07001216test_lazy_prereq JGIT '
1217 type jgit
1218'
1219
Junio C Hamano719c3da2016-01-19 14:09:37 -08001220# SANITY is about "can you correctly predict what the filesystem would
1221# do by only looking at the permission bits of the files and
1222# directories?" A typical example of !SANITY is running the test
1223# suite as root, where a test may expect "chmod -r file && cat file"
1224# to fail because file is supposed to be unreadable after a successful
1225# chmod. In an environment (i.e. combination of what filesystem is
1226# being used and who is running the tests) that lacks SANITY, you may
1227# be able to delete or create a file when the containing directory
1228# doesn't have write permissions, or access a file even if the
1229# containing directory doesn't have read or execute permissions.
1230
Torsten Bögershausenf400e512015-01-27 16:39:01 +01001231test_lazy_prereq SANITY '
1232 mkdir SANETESTD.1 SANETESTD.2 &&
1233
1234 chmod +w SANETESTD.1 SANETESTD.2 &&
1235 >SANETESTD.1/x 2>SANETESTD.2/x &&
1236 chmod -w SANETESTD.1 &&
Junio C Hamano719c3da2016-01-19 14:09:37 -08001237 chmod -r SANETESTD.1/x &&
Torsten Bögershausenf400e512015-01-27 16:39:01 +01001238 chmod -rx SANETESTD.2 ||
SZEDER Gábor165293a2018-11-19 14:13:26 +01001239 BUG "cannot prepare SANETESTD"
Torsten Bögershausenf400e512015-01-27 16:39:01 +01001240
Junio C Hamano719c3da2016-01-19 14:09:37 -08001241 ! test -r SANETESTD.1/x &&
Torsten Bögershausenf400e512015-01-27 16:39:01 +01001242 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1243 status=$?
1244
1245 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1246 rm -rf SANETESTD.1 SANETESTD.2 ||
SZEDER Gábor165293a2018-11-19 14:13:26 +01001247 BUG "cannot clean SANETESTD"
Torsten Bögershausenf400e512015-01-27 16:39:01 +01001248 return $status
1249'
Jeff Kingf838ce52013-03-10 21:31:47 -04001250
Johannes Schindelind98b2c52016-07-21 18:02:54 +02001251test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
Jeff Kingf838ce52013-03-10 21:31:47 -04001252GIT_UNZIP=${GIT_UNZIP:-unzip}
1253test_lazy_prereq UNZIP '
1254 "$GIT_UNZIP" -v
1255 test $? -ne 127
1256'
Jeff King9a308de2015-03-13 00:53:07 -04001257
1258run_with_limited_cmdline () {
1259 (ulimit -s 128 && "$@")
1260}
1261
Ramsay Jones21dac1d2017-09-14 18:24:41 +01001262test_lazy_prereq CMDLINE_LIMIT '
1263 test_have_prereq !MINGW,!CYGWIN &&
1264 run_with_limited_cmdline true
1265'
Jeff King6b9c38e2016-07-11 19:54:18 -04001266
Michael J Gruber4db464f2017-09-07 16:02:20 +02001267run_with_limited_stack () {
1268 (ulimit -s 128 && "$@")
1269}
1270
Ramsay Jones21dac1d2017-09-14 18:24:41 +01001271test_lazy_prereq ULIMIT_STACK_SIZE '
1272 test_have_prereq !MINGW,!CYGWIN &&
1273 run_with_limited_stack true
1274'
Michael J Gruber4db464f2017-09-07 16:02:20 +02001275
Jeff King6b9c38e2016-07-11 19:54:18 -04001276build_option () {
1277 git version --build-options |
1278 sed -ne "s/^$1: //p"
1279}
1280
1281test_lazy_prereq LONG_IS_64BIT '
1282 test 8 -le "$(build_option sizeof-long)"
1283'
Johannes Schindelina07fb052017-04-20 22:52:13 +02001284
Nguyễn Thái Ngọc Duya801a7c2018-03-24 08:44:36 +01001285test_lazy_prereq TIME_IS_64BIT 'test-tool date is64bit'
1286test_lazy_prereq TIME_T_IS_64BIT 'test-tool date time_t-is64bit'
Jeff Kinge9184b02018-04-03 10:01:57 -04001287
1288test_lazy_prereq CURL '
1289 curl --version
1290'
brian m. carlsond16ab632018-05-13 02:24:11 +00001291
1292# SHA1 is a test if the hash algorithm in use is SHA-1. This is both for tests
1293# which will not work with other hash algorithms and tests that work but don't
1294# test anything meaningful (e.g. special values which cause short collisions).
1295test_lazy_prereq SHA1 '
1296 test $(git hash-object /dev/null) = e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
1297'
Johannes Schindelin11aad462018-10-31 13:02:02 -07001298
1299test_lazy_prereq REBASE_P '
1300 test -z "$GIT_TEST_SKIP_REBASE_P"
1301'